
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.model.functions &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.model.functions</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">.. module:: emulsion.model.functions</span>

<span class="sd">.. moduleauthor:: Sébastien Picault &lt;sebastien.picault@inra.fr&gt;</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>

<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span>   <span class="nn">sympy</span>                   <span class="k">import</span> <span class="n">sympify</span><span class="p">,</span> <span class="n">lambdify</span><span class="p">,</span> <span class="n">Symbol</span>
<span class="c1"># BEWARE: using lambdify, by default And and Or fall back to numpy&#39;s</span>
<span class="c1"># *binary* operators, so that more than 3 conditions linked by And or</span>
<span class="c1"># Or trigger a TypeError (&#39;return arrays must be of ArrayType&#39;)</span>
<span class="c1"># see topic addressed there:</span>
<span class="c1"># https://stackoverflow.com/questions/42045906/typeerror-return-arrays-must-be-of-arraytype-using-lambdify-of-sympy-in-python</span>
<span class="c1"># To avoid problems, please use AND / OR (fully in UPPERCASE) instead</span>
<span class="c1"># of And / Or (Capitalized) in the conditions of Emulsion models</span>

<span class="kn">from</span>   <span class="nn">emulsion.tools.misc</span>     <span class="k">import</span> <span class="n">load_module</span>


<span class="c1">#  ______                _   _</span>
<span class="c1"># |  ____|              | | (_)</span>
<span class="c1"># | |__ _   _ _ __   ___| |_ _  ___  _ __  ___</span>
<span class="c1"># |  __| | | | &#39;_ \ / __| __| |/ _ \| &#39;_ \/ __|</span>
<span class="c1"># | |  | |_| | | | | (__| |_| | (_) | | | \__ \</span>
<span class="c1"># |_|   \__,_|_| |_|\___|\__|_|\___/|_| |_|___/</span>

<span class="c1">## Special strings for graphviz/dot formatting</span>
<span class="c1">#ACTION_SYMBOL = &#39;&amp;#9881;&#39;</span>
<span class="c1">#ACTION_SYMBOL = &#39;&amp;#8623;&#39;</span>
<span class="n">CLOCK_SYMBOL</span> <span class="o">=</span> <span class="s1">&#39;&amp;#9719;&#39;</span>
<span class="n">ACTION_SYMBOL</span> <span class="o">=</span> <span class="s1">&#39;&amp;#9670;&#39;</span>
<span class="n">WHEN_SYMBOL</span> <span class="o">=</span> <span class="s1">&#39;odot&#39;</span>
<span class="n">ESCAPE_SYMBOL</span> <span class="o">=</span> <span class="s1">&#39;oinv&#39;</span>
<span class="n">COND_SYMBOL</span> <span class="o">=</span> <span class="s1">&#39;tee&#39;</span>
<span class="n">CROSS_SYMBOL</span> <span class="o">=</span> <span class="s1">&#39;diamond&#39;</span>
<span class="n">EDGE_KEYWORDS</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;rate&#39;</span><span class="p">,</span> <span class="s1">&#39;proba&#39;</span><span class="p">,</span> <span class="s1">&#39;amount&#39;</span><span class="p">,</span> <span class="s1">&#39;amount-all-but&#39;</span><span class="p">]</span>


<span class="c1">### INFORMATION TO ADD TO LEVEL DESCRIPTION WHEN USING aggregation_type</span>
<span class="n">DEFAULT_LEVEL_INFO</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;IBM&#39;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s1">&#39;level&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;IBMProcessManager&#39;</span><span class="p">,</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.managers&#39;</span><span class="p">,</span>
            <span class="s1">&#39;master&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;SimpleView&#39;</span><span class="p">,</span>
                       <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.views&#39;</span><span class="p">}</span>
        <span class="p">},</span>
        <span class="s1">&#39;sublevels&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;EvolvingAtom&#39;</span><span class="p">,</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.atoms&#39;</span>
        <span class="p">}</span>
    <span class="p">},</span>
    <span class="s1">&#39;compartment&#39;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s1">&#39;level&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.managers&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;CompartProcessManager&#39;</span>
        <span class="p">}</span>
    <span class="p">},</span>
    <span class="s1">&#39;hybrid&#39;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s1">&#39;level&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.managers&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;MultiProcessManager&#39;</span><span class="p">,</span>
            <span class="s1">&#39;master&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.views&#39;</span><span class="p">,</span>
                       <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;SimpleView&#39;</span><span class="p">}</span>
        <span class="p">},</span>
        <span class="s1">&#39;sublevels&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.atoms&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;AtomAgent&#39;</span>
        <span class="p">}</span>
    <span class="p">},</span>
    <span class="s1">&#39;metapopulation&#39;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s1">&#39;level&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.managers&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;MetapopProcessManager&#39;</span><span class="p">,</span>
            <span class="s1">&#39;master&#39;</span><span class="p">:</span> <span class="p">{</span>
                <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.views&#39;</span><span class="p">,</span>
                <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;AutoStructuredView&#39;</span><span class="p">,</span>
                <span class="s1">&#39;options&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;key_variable&#39;</span><span class="p">:</span> <span class="s1">&#39;population_id&#39;</span><span class="p">}</span>
            <span class="p">}</span>
        <span class="p">},</span>
    <span class="p">},</span>
<span class="p">}</span>

<span class="c1">### INFORMATION TO ADD TO GROUPING DESCRIPTION WHEN USING aggregation_type</span>
<span class="n">DEFAULT_GROUPING_INFO</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;hybrid&#39;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s1">&#39;compart_manager&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.managers&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;GroupManager&#39;</span>
        <span class="p">},</span>
        <span class="s1">&#39;compart_class&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.views&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;AdaptiveView&#39;</span>
        <span class="p">},</span>
        <span class="s1">&#39;fallback_view&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.views&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;StructuredViewWithCounts&#39;</span>
        <span class="p">},</span>
    <span class="p">},</span>
    <span class="s1">&#39;compartment&#39;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s1">&#39;compart_manager&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.managers&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;GroupManager&#39;</span>
        <span class="p">},</span>
        <span class="s1">&#39;compart_class&#39;</span><span class="p">:</span> <span class="p">{</span>
            <span class="s1">&#39;module&#39;</span><span class="p">:</span> <span class="s1">&#39;emulsion.agent.comparts&#39;</span><span class="p">,</span>
            <span class="s1">&#39;class_name&#39;</span><span class="p">:</span> <span class="s1">&#39;Compartment&#39;</span>
        <span class="p">}</span>
    <span class="p">}</span>
<span class="p">}</span>


<span class="c1">## NOTE: rewritten as callable class to allow serialization (nested functions cannot be serialized)</span>
<div class="viewcode-block" id="make_function"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_function">[docs]</a><span class="k">class</span> <span class="nc">make_function</span><span class="p">:</span>
<div class="viewcode-block" id="make_function.__init__"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_function.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">expression</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">float</span><span class="p">,</span> <span class="n">modules</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;numpy&#39;</span><span class="p">,</span> <span class="s1">&#39;numpy.random&#39;</span><span class="p">,</span> <span class="s1">&#39;math&#39;</span><span class="p">,</span> <span class="s1">&#39;sympy&#39;</span><span class="p">]):</span>
        <span class="sd">&quot;&quot;&quot;Transform the specified sympy expression into a callable class,</span>
<span class="sd">        which can be called on an agent, which substitutes the</span>
<span class="sd">        specified symbols of the expression with an access to either</span>
<span class="sd">        attributes or state variables of the same name in the agent</span>
<span class="sd">        (through the ``get_information`` method) and returns a value</span>
<span class="sd">        of the specified dtype. The transformation uses sympy function</span>
<span class="sd">        ``lambdify`` for better performances, with the specified</span>
<span class="sd">        modules.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        expression: ``str``</span>
<span class="sd">            the expression to transform</span>
<span class="sd">        dtype: ``type``</span>
<span class="sd">            the type in which results are converted to</span>
<span class="sd">        moddules: ``list``</span>
<span class="sd">            list of the names of the modules used to lambdify the expression</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        class:</span>
<span class="sd">            a callable which can be called on an agent</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">symbs</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">expression</span><span class="o">.</span><span class="n">free_symbols</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="o">=</span> <span class="n">dtype</span>
        <span class="n">mods</span> <span class="o">=</span> <span class="p">[</span><span class="n">load_module</span><span class="p">(</span><span class="n">m</span><span class="p">)</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">modules</span><span class="p">]</span>
        <span class="c1"># print(expression, &#39;-&gt;&#39;, self.symbs)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">lambdified</span> <span class="o">=</span> <span class="n">lambdify</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">symbs</span><span class="p">,</span> <span class="n">expression</span><span class="p">,</span> <span class="n">modules</span><span class="o">=</span><span class="n">mods</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="nf">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">agent</span><span class="p">):</span>
        <span class="n">vals</span> <span class="o">=</span> <span class="p">[</span><span class="nb">float</span><span class="p">(</span><span class="n">agent</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">s</span><span class="p">)))</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">symbs</span><span class="p">]</span>
        <span class="c1"># try:</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">lambdified</span><span class="p">(</span><span class="o">*</span><span class="n">vals</span><span class="p">))</span></div>
        <span class="c1"># except TypeError as err:</span>
        <span class="c1">#     print(err.args, err.with_traceback, lambdified)</span>
        <span class="c1">#     print(expression)</span>
        <span class="c1">#     print(symbs)</span>
        <span class="c1">#     print(vals, type(vals))</span>
        <span class="c1">#     print(lambdified.__doc__)</span>
        <span class="c1">#     print(lambdified(7))</span>
        <span class="c1">#     import sys</span>
        <span class="c1">#     sys.exit(-1)</span>


<div class="viewcode-block" id="make_CSV_function"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_CSV_function">[docs]</a><span class="k">class</span> <span class="nc">make_CSV_function</span><span class="p">:</span>
<div class="viewcode-block" id="make_CSV_function.__init__"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_CSV_function.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">expression</span><span class="p">,</span> <span class="n">modules</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;numpy&#39;</span><span class="p">,</span> <span class="s1">&#39;numpy.random&#39;</span><span class="p">,</span> <span class="s1">&#39;math&#39;</span><span class="p">,</span> <span class="s1">&#39;sympy&#39;</span><span class="p">]):</span>
        <span class="sd">&quot;&quot;&quot;Transform the specified sympy expression into a callable class</span>
<span class="sd">        which can be called on a CSV line. The transformation uses</span>
<span class="sd">        sympy function ``lambdify`` for better performances, with the</span>
<span class="sd">        specified modules.</span>


<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        expression: ``str``</span>
<span class="sd">            the expression to transform</span>
<span class="sd">        moddules: ``list``</span>
<span class="sd">            list of the names of the modules used to lambdify the expression</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        class:</span>
<span class="sd">            a callable which can be called on a CSV line</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># print(expression, type(expression))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">symbs</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">expression</span><span class="o">.</span><span class="n">free_symbols</span><span class="p">)</span>
        <span class="n">mods</span> <span class="o">=</span> <span class="p">[</span><span class="n">load_module</span><span class="p">(</span><span class="n">m</span><span class="p">)</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">modules</span><span class="p">]</span>
        <span class="c1"># print(expression, &#39;-&gt;&#39;, symbs)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">lambdified</span> <span class="o">=</span> <span class="n">lambdify</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">symbs</span><span class="p">,</span> <span class="n">expression</span><span class="p">,</span> <span class="n">modules</span><span class="o">=</span><span class="n">mods</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="nf">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">line</span><span class="p">):</span>
        <span class="n">vals</span> <span class="o">=</span> <span class="p">[</span><span class="nb">float</span><span class="p">(</span><span class="n">line</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">s</span><span class="p">)])</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">symbs</span><span class="p">]</span>
        <span class="k">return</span> <span class="nb">float</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">lambdified</span><span class="p">(</span><span class="o">*</span><span class="n">vals</span><span class="p">))</span></div>


<div class="viewcode-block" id="make_when_condition"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_when_condition">[docs]</a><span class="k">class</span> <span class="nc">make_when_condition</span><span class="p">:</span>
<div class="viewcode-block" id="make_when_condition.__init__"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_when_condition.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">expression</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">bool</span><span class="p">,</span> <span class="n">modules</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;numpy&#39;</span><span class="p">,</span> <span class="s1">&#39;numpy.random&#39;</span><span class="p">,</span> <span class="s1">&#39;math&#39;</span><span class="p">,</span> <span class="s1">&#39;sympy&#39;</span><span class="p">]):</span>
        <span class="sd">&quot;&quot;&quot;Transform the specified sympy `expression` into a callable class,</span>
<span class="sd">        which can be called on an agent, which substitutes the</span>
<span class="sd">        specified symbol of the expression with an access to the</span>
<span class="sd">        simulation calendar. The transformation uses sympy function</span>
<span class="sd">        ``lambdify`` for better performances, with the specified</span>
<span class="sd">        modules.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        expression: ``str``</span>
<span class="sd">            the expression to transform</span>
<span class="sd">        dtype: ``type``</span>
<span class="sd">            the type in which results are converted to</span>
<span class="sd">        moddules: ``list``</span>
<span class="sd">            list of the names of the modules used to lambdify the expression</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        class:</span>
<span class="sd">            a callable which can be called on an agent</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1">## General idea: expression should be a boolean test for a</span>
        <span class="c1">## property in the agent -&gt; simulation -&gt; calendar,</span>
        <span class="c1">## e.g. expressions such as &#39;breeding_period&#39; or</span>
        <span class="c1">## &#39;Not(vacation)&#39; call a function associated with</span>
        <span class="c1">## &#39;breeding_period&#39; or &#39;vacation&#39; strings in the</span>
        <span class="c1">## calendar. The function are applied to simulation step and</span>
        <span class="c1">## generated on the basis of the points or intervals defined</span>
        <span class="c1">## in the &#39;calendar&#39; section of the model. This implies that</span>
        <span class="c1">## all agents must have access to the whole simulation (or at</span>
        <span class="c1">## least to the calendar). This also means that an actual</span>
        <span class="c1">## calendar is a subclass of a generic calendar, generated</span>
        <span class="c1">## automatically to be endowed with those properties.</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span> <span class="o">=</span> <span class="n">dtype</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">symbs</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">expression</span><span class="o">.</span><span class="n">free_symbols</span><span class="p">)</span>
        <span class="n">mods</span> <span class="o">=</span> <span class="p">[</span><span class="n">load_module</span><span class="p">(</span><span class="n">m</span><span class="p">)</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">modules</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">lambdified</span> <span class="o">=</span> <span class="n">lambdify</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">symbs</span><span class="p">,</span> <span class="n">expression</span><span class="p">,</span> <span class="n">modules</span><span class="o">=</span><span class="n">mods</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="nf">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">agent</span><span class="p">):</span>
        <span class="n">vals</span> <span class="o">=</span> <span class="p">[</span><span class="n">agent</span><span class="o">.</span><span class="n">evaluate_event</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">s</span><span class="p">))</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">symbs</span><span class="p">]</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">dtype</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">lambdified</span><span class="p">(</span><span class="o">*</span><span class="n">vals</span><span class="p">))</span></div>


<div class="viewcode-block" id="make_duration_condition"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_duration_condition">[docs]</a><span class="k">def</span> <span class="nf">make_duration_condition</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">machine_name</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Build a duration condition associated to the specified state</span>
<span class="sd">    machine and add it to the model. A condition duration, which is</span>
<span class="sd">    intended to specify when an agent is allowed to leave the current</span>
<span class="sd">    state of the state machine, is of the form &#39;step &gt;=</span>
<span class="sd">    _time_to_exit_MACHINE_NAME&#39;, each of those variables being stored</span>
<span class="sd">    in the state variables.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># build the name of the state variable from the name of the state machine</span>
    <span class="n">var_name</span> <span class="o">=</span> <span class="s1">&#39;_time_to_exit_</span><span class="si">{}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)</span>
    <span class="c1"># add the association variable name -&gt; Symbol to the namespace of the model</span>
    <span class="n">model</span><span class="o">.</span><span class="n">_namespace</span><span class="p">[</span><span class="n">var_name</span><span class="p">]</span> <span class="o">=</span> <span class="n">Symbol</span><span class="p">(</span><span class="n">var_name</span><span class="p">)</span>
    <span class="c1"># attach a description</span>
    <span class="n">model</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">var_name</span><span class="p">]</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;desc&#39;</span><span class="p">:</span> <span class="s1">&#39;time step before which this agent is not allowed to exit current state of state machine </span><span class="si">{}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)</span>
    <span class="p">}</span>
    <span class="c1"># return the expression corresponding to the duration condition</span>
    <span class="k">return</span> <span class="s1">&#39;GreaterThan(step, </span><span class="si">{}</span><span class="s1">)&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">var_name</span><span class="p">)</span></div>


<div class="viewcode-block" id="make_duration_init_action"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_duration_init_action">[docs]</a><span class="k">def</span> <span class="nf">make_duration_init_action</span><span class="p">(</span><span class="n">agent</span><span class="p">,</span> <span class="n">duration</span><span class="p">,</span> <span class="n">machine_name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">_</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Action that initializes the &#39;time to exit&#39; for the state of the</span>
<span class="sd">    specified state_machine.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># the action to execute when entering a state associated with a duration</span>
    <span class="n">agent</span><span class="o">.</span><span class="n">update_time_to_exit</span><span class="p">(</span><span class="n">machine_name</span><span class="p">,</span> <span class="n">duration</span><span class="p">)</span></div>


<div class="viewcode-block" id="make_statevar_getter"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_statevar_getter">[docs]</a><span class="k">class</span> <span class="nc">make_statevar_getter</span><span class="p">:</span>
<div class="viewcode-block" id="make_statevar_getter.__init__"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_statevar_getter.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">varname</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Build and return a callable class, which can be called on an agent</span>
<span class="sd">        to return the value of its statevar of the specified name.,</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        varname: ``str``</span>
<span class="sd">            the name of the statevar to get</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        class:</span>
<span class="sd">            a callable which can be called on an agent</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">varname</span> <span class="o">=</span> <span class="n">varname</span></div>

    <span class="k">def</span> <span class="nf">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">agent</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">varname</span><span class="p">]</span></div>

<div class="viewcode-block" id="make_model_value_getter"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_model_value_getter">[docs]</a><span class="k">class</span> <span class="nc">make_model_value_getter</span><span class="p">:</span>
<div class="viewcode-block" id="make_model_value_getter.__init__"><a class="viewcode-back" href="../../../emulsion.model.html#emulsion.model.functions.make_model_value_getter.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value_vame</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Build and return a callable class, which can be called on an agent</span>
<span class="sd">        to return the value of the specified parameter (or expression) in</span>
<span class="sd">        the model.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        value_name: ``str``</span>
<span class="sd">            the name of the statevar to get</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        class:</span>
<span class="sd">            a callable which can be called on an agent</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">value_vame</span> <span class="o">=</span> <span class="n">value_vame</span></div>

    <span class="k">def</span> <span class="nf">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">agent</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">agent</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">value_vame</span><span class="p">)</span></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>